// Code generated by go-swagger; DO NOT EDIT.

package azure

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/vmware-tanzu/tanzu-framework/pkg/v1/tkg/web/server/models"
)

// ImportTKGConfigForAzureReader is a Reader for the ImportTKGConfigForAzure structure.
type ImportTKGConfigForAzureReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ImportTKGConfigForAzureReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImportTKGConfigForAzureOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewImportTKGConfigForAzureBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewImportTKGConfigForAzureUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewImportTKGConfigForAzureInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewImportTKGConfigForAzureOK creates a ImportTKGConfigForAzureOK with default headers values
func NewImportTKGConfigForAzureOK() *ImportTKGConfigForAzureOK {
	return &ImportTKGConfigForAzureOK{}
}

/*ImportTKGConfigForAzureOK handles this case with default header values.

Generated TKG configuration successfully
*/
type ImportTKGConfigForAzureOK struct {
	Payload *models.AzureRegionalClusterParams
}

func (o *ImportTKGConfigForAzureOK) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/config/import][%d] importTKGConfigForAzureOK  %+v", 200, o.Payload)
}

func (o *ImportTKGConfigForAzureOK) GetPayload() *models.AzureRegionalClusterParams {
	return o.Payload
}

func (o *ImportTKGConfigForAzureOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AzureRegionalClusterParams)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportTKGConfigForAzureBadRequest creates a ImportTKGConfigForAzureBadRequest with default headers values
func NewImportTKGConfigForAzureBadRequest() *ImportTKGConfigForAzureBadRequest {
	return &ImportTKGConfigForAzureBadRequest{}
}

/*ImportTKGConfigForAzureBadRequest handles this case with default header values.

Bad request
*/
type ImportTKGConfigForAzureBadRequest struct {
	Payload *models.Error
}

func (o *ImportTKGConfigForAzureBadRequest) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/config/import][%d] importTKGConfigForAzureBadRequest  %+v", 400, o.Payload)
}

func (o *ImportTKGConfigForAzureBadRequest) GetPayload() *models.Error {
	return o.Payload
}

func (o *ImportTKGConfigForAzureBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportTKGConfigForAzureUnauthorized creates a ImportTKGConfigForAzureUnauthorized with default headers values
func NewImportTKGConfigForAzureUnauthorized() *ImportTKGConfigForAzureUnauthorized {
	return &ImportTKGConfigForAzureUnauthorized{}
}

/*ImportTKGConfigForAzureUnauthorized handles this case with default header values.

Incorrect credentials
*/
type ImportTKGConfigForAzureUnauthorized struct {
	Payload *models.Error
}

func (o *ImportTKGConfigForAzureUnauthorized) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/config/import][%d] importTKGConfigForAzureUnauthorized  %+v", 401, o.Payload)
}

func (o *ImportTKGConfigForAzureUnauthorized) GetPayload() *models.Error {
	return o.Payload
}

func (o *ImportTKGConfigForAzureUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportTKGConfigForAzureInternalServerError creates a ImportTKGConfigForAzureInternalServerError with default headers values
func NewImportTKGConfigForAzureInternalServerError() *ImportTKGConfigForAzureInternalServerError {
	return &ImportTKGConfigForAzureInternalServerError{}
}

/*ImportTKGConfigForAzureInternalServerError handles this case with default header values.

Internal server error
*/
type ImportTKGConfigForAzureInternalServerError struct {
	Payload *models.Error
}

func (o *ImportTKGConfigForAzureInternalServerError) Error() string {
	return fmt.Sprintf("[POST /api/providers/azure/config/import][%d] importTKGConfigForAzureInternalServerError  %+v", 500, o.Payload)
}

func (o *ImportTKGConfigForAzureInternalServerError) GetPayload() *models.Error {
	return o.Payload
}

func (o *ImportTKGConfigForAzureInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
